local _, _, ICON_DEFAULT = GetSpellInfo(1130)
local ART = AsmoRaidTracker

local LDB = LibStub("LibDataBroker-1.1")
local AB = AsmoRaidTracker:NewModule("Broker", "AceConsole-3.0")

--------------------------------------------------------------------------------
-- Standard addon methods
function AB:OnInitialize()
    -- Called when the addon is loaded
    self.lDBObject = {
		type = "data source",
		label = "AsmodeusRaidTracker",
		icon = ICON_DEFAULT,
		OnClick = function(self, button)
			if button == "LeftButton" then
				if IsShiftKeyDown() then
					InterfaceOptionsFrame_OpenToCategory(ART.optionsFrame)
				else
					if not ART.displayState.isWindowOpened then
	            		ART:DrawWindow()
	            	end
	            end
			elseif button == "RightButton" then
				if IsShiftKeyDown() then
					ART:OutputCommLog()
				else
					if not ART.inviter.displayState.isWindowOpened then
            			ART.inviter:DrawWindow()
            		end
            	end
			end
		end,
		OnTooltipShow = function(self)
			self:AddLine("Asmodeus Raid Tracker	")
			self:AddLine("Clic gauche : |cFFFFFFFFfenêtre raid")
			self:AddLine("Clic droit : |cFFFFFFFFfenêtre invite")
			self:AddLine("MAJ + Clic gauche : |cFFFFFFFFconfiguration")
			if ART.currentRaid then
				local raid = ART.currentRaid
				self:AddLine(" ")
				if ART.synchronizer.masterName == UnitName("player") then
			    	self:AddLine("|cFF00FF00Raid en cours |cFFFFFFFF(Maître)")
				else
					self:AddLine(fmt("|cFF00FF00Raid en cours |cFFFFFFFF(Esclave de %s)", ART.synchronizer.masterName))
				end
			end
		end,
		OnEnter = function(self)
			GameTooltip:SetOwner(self, "ANCHOR_NONE")
			GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
			GameTooltip:ClearLines()
			AB.lDBObject.OnTooltipShow(GameTooltip)
			GameTooltip:Show()
		end,
	}
	
	LDB:NewDataObject("AsmodeusRaidTracker", self.lDBObject)
end

function AB:OnEnable()
    -- Called when the addon is enabled
    AsmoRaidTracker.broker = self
end

function AB:OnDisable()
    -- Called when the addon is disabled
end